Subject: Re: [REGRESSION] Userland interface breaks due to hard HFSC_FSC requirement

From: Florian Westphal <[email-masked]>
Date: Fri, 6 Oct 2023 14:23:39 +0200

Christian Theune <[email-masked]> wrote:

[ Trimming CCs, adding patch author ]

> it seems that 6.6rc4 is affected as well:
> ----
> commit b3d26c5702c7d6c45456326e56d2ccf3f103e60f
> Author: Budimir Markovic <[email-masked]>
> Date:   Thu Aug 24 01:49:05 2023 -0700
> 
>     net/sched: sch_hfsc: Ensure inner classes have fsc curve
> ——
> 
> I have not found newer commits that would suggest they change any behaviour around this in any way, but I might be wrong.
> 
> Christian
> 
> > On 6. Oct 2023, at 11:01, Linux regression tracking (Thorsten Leemhuis) <[email-masked]> wrote:
> > 
> > On 06.10.23 10:37, Christian Theune wrote:
> >> 
> >> (prefix, I was not aware of the regression reporting process and incorrectly reported this informally with the developers mentioned in the change)
> > 
> > Don't worry too much about that, but thx for taking care of all the
> > details. FWIW, there is one more thing that would be good to know:
> > 
> > Does the problem happen with mainline (e.g. 6.6-rc4) as well? That's
> > relevant, as different people might care[1].
> > 
> > Ciao, Thorsten
> > 
> > [1] this among others is explained here:
> > https://linux-regtracking.leemhuis.info/post/frequent-reasons-why-linux-kernel-bug-reports-are-ignored/
> > 
> >> I upgraded from 6.1.38 to 6.1.55 this morning and it broke my traffic shaping script, leaving me with a non-functional uplink on a remote router.
> >> 
> >> The script errors out like this:
> >> 
> >> Oct 06 05:49:22 wendy00 isp-setup-shaping-start[2053]: + ext=ispA
> >> Oct 06 05:49:22 wendy00 isp-setup-shaping-start[2053]: + ext_ingress=ifb0
> >> Oct 06 05:49:22 wendy00 isp-setup-shaping-start[2053]: + modprobe ifb
> >> Oct 06 05:49:22 wendy00 isp-setup-shaping-start[2053]: + modprobe act_mirred
> >> Oct 06 05:49:22 wendy00 isp-setup-shaping-start[2053]: + tc qdisc del dev ispA root
> >> Oct 06 05:49:22 wendy00 isp-setup-shaping-start[2061]: Error: Cannot delete qdisc with handle of zero.
> >> Oct 06 05:49:22 wendy00 isp-setup-shaping-start[2053]: + true
> >> Oct 06 05:49:22 wendy00 isp-setup-shaping-start[2053]: + tc qdisc del dev ispA ingress
> >> Oct 06 05:49:22 wendy00 isp-setup-shaping-start[2064]: Error: Cannot find specified qdisc on specified device.
> >> Oct 06 05:49:22 wendy00 isp-setup-shaping-start[2053]: + true
> >> Oct 06 05:49:22 wendy00 isp-setup-shaping-start[2053]: + tc qdisc del dev ifb0 root
> >> Oct 06 05:49:22 wendy00 isp-setup-shaping-start[2066]: Error: Cannot delete qdisc with handle of zero.
> >> Oct 06 05:49:22 wendy00 isp-setup-shaping-start[2053]: + true
> >> Oct 06 05:49:22 wendy00 isp-setup-shaping-start[2053]: + tc qdisc del dev ifb0 ingress
> >> Oct 06 05:49:22 wendy00 isp-setup-shaping-start[2067]: Error: Cannot find specified qdisc on specified device.
> >> Oct 06 05:49:22 wendy00 isp-setup-shaping-start[2053]: + true
> >> Oct 06 05:49:22 wendy00 isp-setup-shaping-start[2053]: + tc qdisc add dev ispA handle ffff: ingress
> >> Oct 06 05:49:22 wendy00 isp-setup-shaping-start[2053]: + ifconfig ifb0 up
> >> Oct 06 05:49:22 wendy00 isp-setup-shaping-start[2053]: + tc filter add dev ispA parent ffff: protocol all u32 match u32 0 0 action mirred egress redirect dev ifb0
> >> Oct 06 05:49:22 wendy00 isp-setup-shaping-start[2053]: + tc qdisc add dev ifb0 root handle 1: hfsc default 1
> >> Oct 06 05:49:22 wendy00 isp-setup-shaping-start[2053]: + tc class add dev ifb0 parent 1: classid 1:999 hfsc rt m2 2.5gbit
> >> Oct 06 05:49:22 wendy00 isp-setup-shaping-start[2053]: + tc class add dev ifb0 parent 1:999 classid 1:1 hfsc sc rate 50mbit
> >> Oct 06 05:49:22 wendy00 isp-setup-shaping-start[2077]: Error: Invalid parent - parent class must have FSC.
> >> 
> >> The error message is also a bit weird (but that’s likely due to iproute2 being weird) as the CLI interface for `tc` and the error message do not map well. (I think I would have to choose `hfsc sc` on the parent to enable the FSC option which isn’t mentioned anywhere in the hfsc manpage).
> >> 
> >> The breaking change was introduced in 6.1.53[1] and a multitude of other currently supported kernels:
> >> 
> >> ----
> >> commit a1e820fc7808e42b990d224f40e9b4895503ac40
> >> Author: Budimir Markovic <[email-masked]>
> >> Date: Thu Aug 24 01:49:05 2023 -0700
> >> 
> >> net/sched: sch_hfsc: Ensure inner classes have fsc curve
> >> 
> >> [ Upstream commit b3d26c5702c7d6c45456326e56d2ccf3f103e60f ]
> >> 
> >> HFSC assumes that inner classes have an fsc curve, but it is currently
> >> possible for classes without an fsc curve to become parents. This leads
> >> to bugs including a use-after-free.
> >> 
> >> Don't allow non-root classes without HFSC_FSC to become parents.
> >> 
> >> Fixes: 1da177e4c3f4 ("Linux-2.6.12-rc2")
> >> Reported-by: Budimir Markovic <[email-masked]>
> >> Signed-off-by: Budimir Markovic <[email-masked]>
> >> Acked-by: Jamal Hadi Salim <[email-masked]>
> >> Link: https://lore.kernel.org/r/[email-masked]
> >> Signed-off-by: Jakub Kicinski <[email-masked]>
> >> Signed-off-by: Sasha Levin <[email-masked]>
> >> ----
> >> 
> >> Regards,
> >> Christian
> >> 
> >> [1] https://cdn.kernel.org/pub/linux/kernel/v6.x/ChangeLog-6.1.53
> >> 
> >> #regzbot introduced: a1e820fc7808e42b990d224f40e9b4895503ac40
> >> 
> >> 
> 
> Liebe Grüße,
> Christian Theune
> 
> -- 
> Christian Theune · [email-masked] · +49 345 219401 0
> Flying Circus Internet Operations GmbH · https://flyingcircus.io
> Leipziger Str. 70/71 · 06108 Halle (Saale) · Deutschland
> HR Stendal HRB 21169 · Geschäftsführer: Christian Theune, Christian Zagrodnick